# LE Framework Documentation

## What is it?
**LE** - это легковесный, минималистичный фреймворк на PHP, название это аббревиатура Light Elephant, название может показаться парадоксальным как легкий слон, но так оно и есть, слон - это логотип PHP, от того и слон.

Проект хоть и опубликован в 2021, но был создан еще 14 лет назад в 2007 году, тогда я использовал разные CMS для простейших интернет-магазинов и сайтов визиток, растространеные Shared-хостинги очень тормозили, первое что попытался сделать - доработать CMS и оптимизировать производительность, но в типичной CMS тысячи строк кода со сложной вложенностью классов.

Первая версия интернет-магазина состояла из админки, в которой был список заказов и формы импорта каталога, люди просто загрузали csv файл с товарами и ценами и это все загружалось в базу, на внешней части магазина был просто каталог с кнопкой корзины и сама корзина с несколькими полями для оформления заказа. Проект получился настолько быстрым, что мог работать на самых дешевых хостингах.

Всё это сопровождалось и развивалось долгие годы, накопилась огромная кодовая база, многие интернет-магазины уже ушли на другие решения, но полученное решение я использовал и для консольных скриптов и для различных ботов.

Мне не хотелось бы закопать всё то что получилось, поэтому решил отрефакторить и слегка актуализировать самописный фреймворк, поэтому в 2021 году решил сделать публичную версию.

Код фреймворка настолько простой и минималистичный, что разобраться во всех классах и логике работы можно за пару часов, естественно, не обойдусь без сторонних библиотек других авторов, копирайты будут как в самих файлах, так и в файле **copyrights.txt**

Функционал будет добавляться по мере его подготовки и адаптации под новую логику в этот репозиторий, параллельно будет писаться документация на каждый класс.

По любым вопросам можно общаться на почту <pavelbbb@gmail.com>

---

## Предупреждение
Данный код не имеет ничего общего с работающими на данный момент проектами, структура, логика, названия файлов и классов, почти все перепиливается с нуля, тут не будет конкретных кастомных модулей созданных для конкретных проектов, только фундаментальный функционал для быстрого создания специализированных приложений на PHP.

## Базовые классы
> Документация в разработке, если нет ссылки, значит еще не написал
* LE_FS - класс для работы с файлами
* [LE_IMG](core_classes/LE_IMG.md) - класс для работы с изображениями
* LE_MYSQL - класс для работы с базой MYSQL
* LE_SQLITE - класс для работы с базой SQLITE
* LE_TPL - шаблонизатор
* [LE_СURL](core_classes/LE_CURL.md) - класс для выполнения HTTP запросов, работы с API и др, обертка над cURL
